-- CXPACKET WAIT STATS by AMit Bansal
--

-- first clear the wait stats

DBCC SQLPERF('sys.dm_os_wait_stats',CLEAR);


-- observe the wait stats

SELECT TOP 10
        wait_type ,
        max_wait_time_ms wait_time_ms ,
        signal_wait_time_ms ,
        wait_time_ms - signal_wait_time_ms AS resource_wait_time_ms ,
        CASE WHEN wait_time_ms = 0 THEN 0 ELSE 100.0 * wait_time_ms / SUM(wait_time_ms) OVER ( ) END
                                    AS percent_total_waits ,
        CASE WHEN signal_wait_time_ms = 0 THEN 0 ELSE 100.0 * signal_wait_time_ms / SUM(signal_wait_time_ms) OVER ( ) END
                                    AS percent_total_signal_waits ,
        CASE WHEN wait_time_ms = 0 THEN 0 ELSE 100.0 * ( wait_time_ms - signal_wait_time_ms )
        / SUM(wait_time_ms) OVER ( ) END AS percent_total_resource_waits
FROM    sys.dm_os_wait_stats
WHERE   wait_time_ms > 0 -- remove zero wait_time
        --AND wait_type NOT IN -- filter out additional system waits


-- run the following query
-- turn on the execution plan
-- after you run the query go back and run the wait stats query again...

use AdventureWorks2008
GO

select * from sales.SalesOrderDetail
order by LineTotal DESC
GO

-- clear the wait stats again

DBCC SQLPERF('sys.dm_os_wait_stats',CLEAR);


-- try the same with MAXDOP option
-- turn on the execution plan
-- after you run the query go back and run the wait stats query again...

select * from sales.SalesOrderDetail
order by LineTotal DESC
OPTION (MAXDOP 2)
GO

-- conclusion ??